      subroutine poppbry (wk)
c
c=======================================================================
c                                                                    ===
c  This routine extracts the pressure/transport boundary data from a ===
c  2D array for extraction by the boundary filter.                   ===
c                                                                    ===
c  ------                                                            ===
c  Input:                                                            ===
c  ------                                                            ===
c                                                                    ===
c     WK  2D array with boundary data on its edges.  (real array)    ===
c                                                                    ===
c  -------                                                           ===
c  Output:                                                           ===
c  -------                                                           ===
c                                                                    ===
c  Common Blocks:                                                    ===
c                                                                    ===
c  /BNDATA/                                                          ===
c                                                                    ===
c     PO  Pressure/transport boundary data.  (real array)            ===
c                                                                    ===
c  ------                                                            ===
c  Calls:                                                            ===
c  ------                                                            ===
c                                                                    ===
c     none                                                           ===
c                                                                    ===
c=======================================================================
c
c-----------------------------------------------------------------------
c  Define global data
c-----------------------------------------------------------------------
c
#include <cdefs.h>
#include <param.h>
#include <bndata.h>
c
c-----------------------------------------------------------------------
c  Define local data.
c-----------------------------------------------------------------------
c
      integer i
#ifndef cyclic
     &        ,j
#endif
      FLOAT
     &     wk(imt,jmt)
c
c
c=======================================================================
c  Begin executable code.
c=======================================================================
c
c-----------------------------------------------------------------------
c  Extract the boundary data from the 2D array.
c-----------------------------------------------------------------------
c
c  Southern and northern boundaries.
c
      do 10 i = 1, imt
        po(i,1,south) = wk(i,1)
        po(i,1,north) = wk(i,jmt)
  10  continue
c
#ifndef cyclic
c  Western and eastern boundaries.
c
      do 20 j = 1, jmt
        po(j,1,west) = wk(1,j)
        po(j,1,east) = wk(imt,j)
  20  continue
c
#endif
      return
      end
