c
c=======================================================================
c  Include file "scalar.h"
c=======================================================================
c
#ifndef rmdocinc
c  ACOR     coefficient for implicit tratment of Coriolis term:
c           ACOR=0.0   fully explicit.
c           ACOR=0.5   centers the weight equally at time TAU.
c           ACOR=1.0   fully implicit.
c  AH       coefficient for horizontal mixing of tracers (cm^2/s).
c  AM       coefficient for horizontal mixing of momentum (cm^2/s).
c  CRIT     criterion for convergence of relaxation.
c  C2DTSF   twice the length of timestep on transport stream function,
c           except during mixing timesteps (sec).
c  C2DTTS   twice the length of timestep on tracers, except during 
c           mixing timesteps (sec).
c  C2DTUV   twice the length of timestep on internal mode velocities,
c           except during mixing timesteps (sec).
c  DTSF     length of timestep on transport stream function (sec).
c  DTTS     length of timestep on tracer (sec).
c  DTUV     length of timestep on internal mode velocities (sec).
c  GRAV     acceleration due to gravity (cm/s^2).
c  OMEGA    rate of rotation of the (Earth) coordinate system (1/sec).
c  PRMS     current transport stream function RMS used for convergence.
c  RADIAN   number of radians in a degree.
c  RADIUS   average radius of the Earth.
c  SOR      coefficient for over-relaxation.
c
c=======================================================================
c
#endif
      common /scalar/ dtts,dtuv,dtsf,c2dtts,c2dtuv,c2dtsf,ah,am,acor,
     *       crit,sor,omega,radius,grav,radian,prms
      FLOAT 
     *      dtts,dtuv,dtsf,c2dtts,c2dtuv,c2dtsf,ah,am,acor,crit,sor,
     *      omega,radius,grav,radian,prms
